import { Command } from '@oclif/core';
import { DriveFileItem } from '../types/drive.types';
export default class DownloadFile extends Command {
    static readonly args: {};
    static readonly description = "Download and decrypts a file from Internxt Drive to a directory. The file name will be the same as the file name in your Drive.";
    static readonly aliases: string[];
    static readonly examples: string[];
    static readonly flags: {
        id: import("@oclif/core/lib/interfaces").OptionFlag<string | undefined, import("@oclif/core/lib/interfaces").CustomOptions>;
        directory: import("@oclif/core/lib/interfaces").OptionFlag<string | undefined, import("@oclif/core/lib/interfaces").CustomOptions>;
        overwrite: import("@oclif/core/lib/interfaces").BooleanFlag<boolean>;
        'non-interactive': import("@oclif/core/lib/interfaces").BooleanFlag<boolean>;
    };
    static readonly enableJsonFlag = true;
    run: () => Promise<{
        success: boolean;
        message: string;
        file: DriveFileItem;
    }>;
    catch: (error: Error) => Promise<never>;
    private getFileUuid;
    private getDirectory;
    private getFileMetadata;
    private getDownloadPath;
    private prepareNetwork;
}
