import { Command } from '@oclif/core';
export default class Login extends Command {
    static readonly args: {};
    static readonly description = "Logs into an Internxt account. If the account is two-factor protected, then an extra code will be required.";
    static readonly aliases: never[];
    static readonly examples: string[];
    static readonly flags: {
        email: import("@oclif/core/lib/interfaces").OptionFlag<string | undefined, import("@oclif/core/lib/interfaces").CustomOptions>;
        password: import("@oclif/core/lib/interfaces").OptionFlag<string | undefined, import("@oclif/core/lib/interfaces").CustomOptions>;
        twofactor: import("@oclif/core/lib/interfaces").OptionFlag<string | undefined, import("@oclif/core/lib/interfaces").CustomOptions>;
        'non-interactive': import("@oclif/core/lib/interfaces").BooleanFlag<boolean>;
    };
    static readonly enableJsonFlag = true;
    run: () => Promise<{
        success: boolean;
        message: string;
        login: import("../types/command.types").LoginCredentials;
    }>;
    catch: (error: Error) => Promise<never>;
    private getEmail;
    private getPassword;
    private getTwoFactorCode;
}
