"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
module.exports = {
    async up(queryInterface, Sequelize) {
        await queryInterface.addColumn('folders', 'parent_uuid', {
            type: Sequelize.UUIDV4,
            references: {
                model: 'folders',
                key: 'uuid',
            },
        });
        await queryInterface.addColumn('files', 'folder_uuid', {
            type: Sequelize.UUIDV4,
            references: {
                model: 'files',
                key: 'uuid',
            },
        });
    },
    async down(queryInterface) {
        await queryInterface.removeColumn('folders', 'parent_uuid');
        await queryInterface.removeColumn('files', 'folder_uuid');
    },
};
