import { DriveFileItem, DriveFolderItem } from '../../types/drive.types';
import { DriveFileRepository } from './drive-file/drive-file.repository';
import { DriveFolderRepository } from './drive-folder/drive-folder.repository';
import { DriveFile } from './drive-file/drive-file.domain';
import { DriveFolder } from './drive-folder/drive-folder.domain';
export declare class DriveDatabaseManager {
    private readonly driveFileRepository;
    private readonly driveFolderRepository;
    private static readonly sequelize;
    constructor(driveFileRepository: DriveFileRepository, driveFolderRepository: DriveFolderRepository);
    static readonly init: () => Promise<void>;
    static readonly clean: () => Promise<void>;
    findFileByRelativePath: (relativePath: string) => Promise<DriveFile | null>;
    findFolderByRelativePath: (relativePath: string) => Promise<DriveFolder | null>;
    createFolder: (driveFolder: DriveFolderItem, relativePath: string) => Promise<DriveFolder>;
    createFile: (driveFile: DriveFileItem, relativePath: string) => Promise<DriveFile>;
    buildRelativePathForFile: (fileName: string, parentId: number | null) => Promise<string>;
    buildRelativePathForFolder: (folderName: string, parentId: number | null) => Promise<string>;
    deleteFileById: (id: number) => Promise<void>;
    deleteFolderById: (id: number) => Promise<void>;
    deleteFileByPath: (relativePath: string) => Promise<void>;
    deleteFolderByPath: (relativePath: string) => Promise<void>;
}
