import { DriveFileItem } from '../../../types/drive.types';
import { DriveFileModel } from './drive-file.model';
import { DriveFile } from './drive-file.domain';
export declare class DriveFileRepository {
    findByRelativePath: (relativePath: DriveFile["relativePath"]) => Promise<DriveFile | null>;
    findById: (id: DriveFile["id"]) => Promise<DriveFile | null>;
    deleteById: (id: DriveFile["id"]) => Promise<void>;
    createFile: (driveFileItem: DriveFileItem, relativePath: string) => Promise<DriveFile>;
    toDomain: (model: DriveFileModel) => DriveFile;
    static readonly clean: () => Promise<void>;
}
