import { DriveFolderItem } from '../../../types/drive.types';
import { DriveFolder } from './drive-folder.domain';
import { DriveFolderModel } from './drive-folder.model';
export declare class DriveFolderRepository {
    findByRelativePath: (relativePath: DriveFolder["relativePath"]) => Promise<DriveFolder | null>;
    findById: (id: DriveFolder["id"]) => Promise<DriveFolder | null>;
    deleteById: (id: DriveFolder["id"]) => Promise<void>;
    createFolder: (driveFolderItem: DriveFolderItem, relativePath: string) => Promise<DriveFolder>;
    toDomain: (model: DriveFolderModel) => DriveFolder;
    static readonly clean: () => Promise<void>;
}
