import { FetchPaginatedFile, FetchPaginatedFolder } from '@internxt/sdk/dist/drive/storage/types';
import { StorageTypes } from '@internxt/sdk/dist/drive';
import { DriveFolderItem } from '../../types/drive.types';
import { RequestCanceler } from '@internxt/sdk/dist/shared/http/types';
export declare class DriveFolderService {
    static readonly instance: DriveFolderService;
    getFolderMetaByUuid: (uuid: string) => Promise<DriveFolderItem>;
    getFolderMetaById: (id: number) => Promise<DriveFolderItem>;
    getFolderContent: (folderUuid: string) => Promise<{
        folders: FetchPaginatedFolder[];
        files: FetchPaginatedFile[];
    }>;
    private readonly getAllSubfolders;
    private readonly getAllSubfiles;
    moveFolder: (payload: StorageTypes.MoveFolderUuidPayload) => Promise<StorageTypes.FolderMeta>;
    createFolder(payload: StorageTypes.CreateFolderByUuidPayload): [Promise<StorageTypes.CreateFolderResponse>, RequestCanceler];
    renameFolder: (payload: {
        folderUuid: string;
        name: string;
    }) => Promise<void>;
    getFolderMetadataByPath: (path: string) => Promise<DriveFolderItem>;
}
