export declare class KeysService {
    static readonly instance: KeysService;
    assertPrivateKeyIsValid: (privateKey: string, password: string) => Promise<void>;
    encryptPrivateKey: (privateKey: string, password: string) => string;
    decryptPrivateKey: (privateKey: string, password: string) => string;
    assertValidateKeys: (privateKey: string, publicKey: string) => Promise<void>;
    isValidKey: (key: string) => Promise<boolean>;
    generateNewKeysWithEncrypted: (password: string) => Promise<{
        privateKeyArmored: string;
        privateKeyArmoredEncrypted: string;
        publicKeyArmored: string;
        revocationCertificate: string;
    }>;
}
