"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.KeysService = void 0;
const lib_1 = require("@internxt/lib");
const openpgp = __importStar(require("openpgp"));
const keys_types_1 = require("../types/keys.types");
const crypto_utils_1 = require("../utils/crypto.utils");
class KeysService {
    static instance = new KeysService();
    assertPrivateKeyIsValid = async (privateKey, password) => {
        let privateKeyDecrypted;
        let badIterations = true;
        try {
            lib_1.aes.decrypt(privateKey, password, 9999);
        }
        catch {
            badIterations = false;
        }
        if (badIterations === true)
            throw new keys_types_1.WrongIterationsToEncryptPrivateKeyError();
        let badEncrypted = false;
        try {
            privateKeyDecrypted = this.decryptPrivateKey(privateKey, password);
        }
        catch {
            badEncrypted = true;
        }
        let hasValidFormat = false;
        try {
            if (privateKeyDecrypted !== undefined) {
                hasValidFormat = await this.isValidKey(privateKeyDecrypted);
            }
        }
        catch {
        }
        if (badEncrypted === true)
            throw new keys_types_1.CorruptedEncryptedPrivateKeyError();
        if (hasValidFormat === false)
            throw new keys_types_1.BadEncodedPrivateKeyError();
    };
    encryptPrivateKey = (privateKey, password) => {
        return lib_1.aes.encrypt(privateKey, password, crypto_utils_1.CryptoUtils.getAesInit());
    };
    decryptPrivateKey = (privateKey, password) => {
        return lib_1.aes.decrypt(privateKey, password);
    };
    assertValidateKeys = async (privateKey, publicKey) => {
        const publicKeyArmored = await openpgp.readKey({ armoredKey: publicKey });
        const privateKeyArmored = await openpgp.readPrivateKey({ armoredKey: privateKey });
        const plainMessage = 'validate-keys';
        const originalText = await openpgp.createMessage({ text: plainMessage });
        const encryptedMessage = await openpgp.encrypt({
            message: originalText,
            encryptionKeys: publicKeyArmored,
        });
        const decryptedMessage = (await openpgp.decrypt({
            message: await openpgp.readMessage({ armoredMessage: encryptedMessage }),
            verificationKeys: publicKeyArmored,
            decryptionKeys: privateKeyArmored,
        })).data;
        if (decryptedMessage !== plainMessage) {
            throw new keys_types_1.KeysDoNotMatchError();
        }
    };
    isValidKey = async (key) => {
        try {
            await openpgp.readKey({ armoredKey: key });
            return true;
        }
        catch {
            return false;
        }
    };
    generateNewKeysWithEncrypted = async (password) => {
        const { privateKey, publicKey, revocationCertificate } = await openpgp.generateKey({
            userIDs: [{ email: 'inxt@inxt.com' }],
            curve: 'ed25519',
        });
        return {
            privateKeyArmored: privateKey,
            privateKeyArmoredEncrypted: this.encryptPrivateKey(privateKey, password),
            publicKeyArmored: Buffer.from(publicKey).toString('base64'),
            revocationCertificate: Buffer.from(revocationCertificate).toString('base64'),
        };
    };
}
exports.KeysService = KeysService;
