import { UserSettings } from '@internxt/sdk/dist/shared/types/userSettings';
export interface LoginCredentials {
    user: UserSettings;
    token: string;
    newToken: string;
    lastLoggedInAt: string;
    lastTokenRefreshAt: string;
}
export interface WebdavConfig {
    port: string;
    protocol: 'http' | 'https';
}
export declare class NotValidEmailError extends Error {
    constructor();
}
export declare class EmptyPasswordError extends Error {
    constructor();
}
export declare class NotValidTwoFactorCodeError extends Error {
    constructor();
}
export declare class NotValidFolderUuidError extends Error {
    constructor();
}
export declare class NotValidFileUuidError extends Error {
    constructor();
}
export declare class NoRootFolderIdFoundError extends Error {
    constructor();
}
export declare class MissingCredentialsError extends Error {
    constructor();
}
export declare class ExpiredCredentialsError extends Error {
    constructor();
}
export declare class InvalidCredentialsError extends Error {
    constructor();
}
export declare class EmptyFileNameError extends Error {
    constructor();
}
export declare class EmptyFolderNameError extends Error {
    constructor();
}
export declare class NotValidPortError extends Error {
    constructor();
}
export declare class NotValidDirectoryError extends Error {
    constructor();
}
export declare class NotValidFileError extends Error {
    constructor();
}
export interface PaginatedItem {
    name: string;
    type: string;
    id: string;
    size: string;
    modified: string;
}
export interface PromptOptions {
    type: 'input' | 'password' | 'mask' | 'confirm';
    confirm?: {
        default: boolean;
    };
}
