"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.KeysDoNotMatchError = exports.CorruptedEncryptedPrivateKeyError = exports.WrongIterationsToEncryptPrivateKeyError = exports.BadEncodedPrivateKeyError = void 0;
class BadEncodedPrivateKeyError extends Error {
    constructor() {
        super('Private key is bad encoded');
        Object.setPrototypeOf(this, BadEncodedPrivateKeyError.prototype);
    }
}
exports.BadEncodedPrivateKeyError = BadEncodedPrivateKeyError;
class WrongIterationsToEncryptPrivateKeyError extends Error {
    constructor() {
        super('Private key was encrypted using the wrong iterations number');
        Object.setPrototypeOf(this, WrongIterationsToEncryptPrivateKeyError.prototype);
    }
}
exports.WrongIterationsToEncryptPrivateKeyError = WrongIterationsToEncryptPrivateKeyError;
class CorruptedEncryptedPrivateKeyError extends Error {
    constructor() {
        super('Private key is corrupted');
        Object.setPrototypeOf(this, CorruptedEncryptedPrivateKeyError.prototype);
    }
}
exports.CorruptedEncryptedPrivateKeyError = CorruptedEncryptedPrivateKeyError;
class KeysDoNotMatchError extends Error {
    constructor() {
        super('Keys do not match');
        Object.setPrototypeOf(this, KeysDoNotMatchError.prototype);
    }
}
exports.KeysDoNotMatchError = KeysDoNotMatchError;
