import cliProgress from 'cli-progress';
import { Header } from 'tty-table';
import { PromptOptions } from '../types/command.types';
export declare class CLIUtils {
    static readonly clearPreviousLine: () => void;
    static readonly warning: (reporter: (message: string) => void, message: string) => void;
    static readonly error: (reporter: (message: string) => void, message: string) => void;
    static readonly doing: (message: string) => void;
    static readonly success: (reporter: (message: string) => void, message: string) => void;
    static readonly log: (reporter: (message: string) => void, message: string) => void;
    static readonly done: () => void;
    static readonly progress: (opts: cliProgress.Options) => cliProgress.SingleBar;
    static readonly table: (reporter: (message: string) => void, header: Header[], rows: object[]) => void;
    static readonly generateTableHeaderFromType: <T extends object>() => Header[];
    static readonly CommonFlags: {
        'non-interactive': import("@oclif/core/lib/interfaces").BooleanFlag<boolean>;
    };
    static readonly getValueFromFlag: (flag: {
        value?: string;
        name: string;
    }, command: {
        nonInteractive: boolean;
        maxAttempts?: number;
        prompt: {
            message: string;
            options: PromptOptions;
        };
    }, validation: {
        validate: (value: string) => Promise<boolean> | boolean;
        error: Error;
        canBeEmpty?: boolean;
    }, reporter: (message: string) => void) => Promise<string>;
    private static readonly promptWithAttempts;
    static readonly timer: () => {
        stop: () => number;
    };
    static readonly parseEmpty: (input: string) => Promise<string>;
}
export declare class NoFlagProvidedError extends Error {
    constructor(flag: string);
}
