"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DriveUtils = void 0;
class DriveUtils {
    static driveFileMetaToItem(fileMeta) {
        return {
            uuid: fileMeta.uuid ?? '',
            status: fileMeta.status,
            folderId: fileMeta.folderId ?? fileMeta.folder_id,
            folderUuid: fileMeta.folderUuid,
            size: fileMeta.size,
            encryptedName: fileMeta.name,
            name: fileMeta.plainName ?? fileMeta.name,
            bucket: fileMeta.bucket,
            createdAt: new Date(fileMeta.createdAt),
            updatedAt: new Date(fileMeta.updatedAt),
            fileId: fileMeta.fileId,
            id: fileMeta.id,
            type: fileMeta.type,
        };
    }
    static driveFolderMetaToItem(folderMeta) {
        return {
            uuid: folderMeta.uuid,
            id: folderMeta.id,
            bucket: folderMeta.bucket,
            status: folderMeta.deleted || folderMeta.removed ? 'TRASHED' : 'EXISTS',
            name: folderMeta.plainName ?? folderMeta.name,
            encryptedName: folderMeta.name,
            parentId: folderMeta.parentId,
            parentUuid: folderMeta.parentUuid,
            createdAt: new Date(folderMeta.createdAt),
            updatedAt: new Date(folderMeta.updatedAt),
        };
    }
}
exports.DriveUtils = DriveUtils;
