import { Request } from 'express';
import { WebDavRequestedResource } from '../types/webdav.types';
import { DriveFile } from '../services/database/drive-file/drive-file.domain';
import { DriveFolder } from '../services/database/drive-folder/drive-folder.domain';
import { DriveDatabaseManager } from '../services/database/drive-database-manager.service';
import { DriveFolderService } from '../services/drive/drive-folder.service';
import { DriveFileService } from '../services/drive/drive-file.service';
import { DriveFileItem, DriveFolderItem } from '../types/drive.types';
export declare class WebDavUtils {
    static joinURL(...pathComponents: string[]): string;
    static removeHostFromURL(completeURL: string): string;
    static getRequestedResource(urlObject: string | Request): Promise<WebDavRequestedResource>;
    static getDatabaseItemFromResource(resource: WebDavRequestedResource, driveDatabaseManager: DriveDatabaseManager): Promise<DriveFileItem | DriveFolderItem | null>;
    static setDatabaseItem(type: 'file' | 'folder', driveItem: DriveFileItem | DriveFolderItem, driveDatabaseManager: DriveDatabaseManager, relativePath: string): Promise<DriveFolder | DriveFile | undefined>;
    static getDriveItemFromResource(resource: WebDavRequestedResource, driveFolderService?: DriveFolderService, driveFileService?: DriveFileService): Promise<DriveFileItem | DriveFolderItem | undefined>;
    static getAndSearchItemFromResource({ resource, driveDatabaseManager, driveFolderService, driveFileService, }: {
        resource: WebDavRequestedResource;
        driveDatabaseManager: DriveDatabaseManager;
        driveFolderService?: DriveFolderService;
        driveFileService?: DriveFileService;
    }): Promise<DriveFileItem | DriveFolderItem>;
}
