"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AuthMiddleware = void 0;
const sdk_manager_service_1 = require("../../services/sdk-manager.service");
const logger_utils_1 = require("../../utils/logger.utils");
const AuthMiddleware = (authService) => {
    return (req, res, next) => {
        (async () => {
            try {
                const { token, newToken, user } = await authService.getAuthDetails();
                sdk_manager_service_1.SdkManager.init({
                    token,
                    newToken,
                });
                req.user = {
                    uuid: user.uuid,
                    rootFolderId: user.root_folder_id,
                };
                next();
            }
            catch (error) {
                logger_utils_1.webdavLogger.error('Error from AuthMiddleware: ' + error.message);
                res.status(401).send({ error: error.message });
            }
        })();
    };
};
exports.AuthMiddleware = AuthMiddleware;
