"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorHandlingMiddleware = void 0;
const logger_utils_1 = require("../../utils/logger.utils");
const ErrorHandlingMiddleware = (err, req, res, _) => {
    logger_utils_1.webdavLogger.error(`[ERROR MIDDLEWARE] [${req.method.toUpperCase()} - ${req.url}]`, err);
    if ('statusCode' in err) {
        res.status(err.statusCode).send({
            error: {
                message: err.message,
            },
        });
    }
    else {
        res.status(500).send({
            error: {
                message: 'message' in err ? err.message : 'Something went wrong',
            },
        });
    }
};
exports.ErrorHandlingMiddleware = ErrorHandlingMiddleware;
