"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DownloadDynamicStrategy = void 0;
var strategy_1 = require("./strategy");
var _1 = require(".");
var __1 = require("..");
var DownloadDynamicStrategy = /** @class */ (function (_super) {
    __extends(DownloadDynamicStrategy, _super);
    function DownloadDynamicStrategy(params) {
        var _this = _super.call(this) || this;
        _this.iv = Buffer.alloc(0);
        _this.fk = Buffer.alloc(0);
        _this.params = params;
        return _this;
    }
    DownloadDynamicStrategy.prototype.download = function (mirrors) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (mirrors.length === 1) {
                            this.strategy = new _1.DownloadOneShardStrategy(this.params);
                        }
                        else {
                            this.strategy = new _1.DownloadOneStreamStrategy(this.params);
                        }
                        this.strategy.iv = this.iv;
                        this.strategy.fileEncryptionKey = this.fk;
                        this.strategy.once(__1.Events.Download.Start, function () {
                            _this.emit(__1.Events.Download.Start);
                        });
                        this.strategy.once(__1.Events.Download.Ready, function (decipher) {
                            _this.emit(__1.Events.Download.Ready, decipher);
                        });
                        this.strategy.once(__1.Events.Download.Error, function (err) {
                            _this.emit(__1.Events.Download.Error, err);
                        });
                        this.strategy.once(__1.Events.Download.Abort, function () {
                            _this.emit(__1.Events.Download.Abort);
                        });
                        this.strategy.on(__1.Events.Download.Progress, function (progress) {
                            _this.emit(__1.Events.Download.Progress, progress);
                        });
                        return [4 /*yield*/, this.strategy.download(mirrors)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    DownloadDynamicStrategy.prototype.setIv = function (iv) {
        this.iv = iv;
    };
    DownloadDynamicStrategy.prototype.setFileEncryptionKey = function (fk) {
        this.fk = fk;
    };
    DownloadDynamicStrategy.prototype.abort = function () {
        var _a;
        (_a = this.strategy) === null || _a === void 0 ? void 0 : _a.abort();
    };
    return DownloadDynamicStrategy;
}(strategy_1.DownloadStrategy));
exports.DownloadDynamicStrategy = DownloadDynamicStrategy;
