import { DownloadInvalidMnemonicError } from './download';
import { UploadInvalidMnemonicError } from './upload';
type NetworkError = UploadInvalidMnemonicError | DownloadInvalidMnemonicError | Error;
export type NetworkUploadContext = {
    bucketId: string;
    fileSize: number;
    user: string;
    pass: string;
    crypto: {
        index: string;
        mnemonic?: string;
        key: string;
        iv: string;
    };
};
export type NetworkDownloadContext = {
    bucketId: string;
    fileId: string;
    user: string;
    pass: string;
    token: string;
    crypto: {
        index: string;
        mnemonic?: string;
        key: string;
        iv: string;
    };
};
export type NetworkContext = NetworkUploadContext | NetworkDownloadContext;
export declare class ErrorWithContext extends Error {
    context: Partial<NetworkContext>;
    constructor(context: Partial<NetworkContext>);
}
export declare function getNetworkErrorContext(input: NetworkContext, err: NetworkError): Partial<NetworkContext>;
export {};
