import { CreatePhotoData, Photo, PhotoId, PhotosSdkModel, PhotoStatus } from '..';
import { PhotoWithDownloadLink, PhotoExistsPayload, PhotoExistsData, PhotosUsage, UpdatePhotoPayload, PhotosCount, PhotosSortBy } from '../types';
export default class PhotosSubmodule {
    private model;
    constructor(model: PhotosSdkModel);
    getPhotoById(photoId: PhotoId): Promise<Photo>;
    getPhotosSorted(filter: {
        status?: PhotoStatus;
        updatedAt?: Date;
    }, sort: {
        sortBy: PhotosSortBy;
        sortType: 'ASC' | 'DESC';
    }, skip: number, limit: number, includeDownloadLinks: true): Promise<{
        results: PhotoWithDownloadLink[];
        bucketId: string;
    }>;
    getPhotosSorted(filter: {
        status?: PhotoStatus;
        updatedAt?: Date;
    }, sort: {
        sortBy: PhotosSortBy;
        sortType: 'ASC' | 'DESC';
    }, skip: number, limit: number, includeDownloadLinks: false): Promise<{
        results: Photo[];
        bucketId: string;
    }>;
    getPhotos(filter: {
        name?: string;
        status?: PhotoStatus;
        updatedAt?: Date;
    }, skip: number, limit: number): Promise<{
        results: Photo[];
        bucketId: string;
    }>;
    getPhotos(filter: {
        name?: string;
        status?: PhotoStatus;
        updatedAt?: Date;
    }, skip: number, limit: number, includeDownloadLinks: true): Promise<{
        results: PhotoWithDownloadLink[];
        bucketId: string;
    }>;
    createPhoto(data: CreatePhotoData): Promise<Photo>;
    findOrCreatePhoto(data: CreatePhotoData): Promise<Photo>;
    deletePhotosById(photos: {
        id: PhotoId;
    }[]): Promise<void>;
    deletePhotoById(photoId: PhotoId): Promise<void>;
    trashPhotosById(photos: {
        id: PhotoId;
    }[]): Promise<void>;
    trashPhotoById(photoId: PhotoId): Promise<void>;
    getUsage(): Promise<PhotosUsage>;
    photosExists(photosExistPayload: PhotoExistsPayload[]): Promise<PhotoExistsData[]>;
    updatePhoto(photoId: PhotoId, data: UpdatePhotoPayload): Promise<{
        message: string;
    }>;
    getCount(): Promise<PhotosCount>;
    private parse;
}
