"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = __importDefault(require("axios"));
var utils_1 = require("../../utils");
var UsersSubmodule = /** @class */ (function () {
    function UsersSubmodule(model) {
        this.model = model;
    }
    UsersSubmodule.prototype.initialize = function (data) {
        var _this = this;
        return axios_1.default
            .post("".concat(this.model.baseUrl, "/users"), {
            mac: data.mac,
            name: data.name,
        }, {
            headers: {
                Authorization: "Bearer ".concat(this.model.accessToken),
                'internxt-network-pass': data.bridgePassword,
                'internxt-network-user': data.bridgeUser,
            },
        })
            .then(function (res) { return _this.parse(res.data); })
            .catch(function (err) {
            throw new Error((0, utils_1.extractAxiosErrorMessage)(err));
        });
    };
    UsersSubmodule.prototype.parse = function (json) {
        return __assign(__assign({}, json), { createdAt: new Date(json.createdAt), updatedAt: new Date(json.updatedAt) });
    };
    return UsersSubmodule;
}());
exports.default = UsersSubmodule;
