import { BasicAuth, Token } from '../../auth';
export interface CustomHeaders {
    [key: string]: string;
}
type InternxtHeaders = {
    'content-type': string;
    'internxt-version': string;
    'internxt-client': string;
    'x-share-password'?: string;
    Authorization?: string;
    'x-token'?: string;
    'internxt-resources-token'?: string;
};
export declare function basicHeaders(clientName: string, clientVersion: string): InternxtHeaders;
export declare function basicHeadersWithPassword(clientName: string, clientVersion: string, password: string): InternxtHeaders;
export declare function headersWithToken(clientName: string, clientVersion: string, token: Token, workspaceToken?: Token, customHeaders?: CustomHeaders): InternxtHeaders;
export declare function headersWithTokenAndPassword(clientName: string, clientVersion: string, token: Token, workspaceToken: Token | undefined, password: string): InternxtHeaders;
export declare function headersWithBasicAuth(clientName: string, clientVersion: string, auth: BasicAuth, workspaceToken?: Token): InternxtHeaders;
export declare function headersWithAuthToken(clientName: string, clientVersion: string, token: Token, workspaceToken?: Token): InternxtHeaders;
export declare function addResourcesTokenToHeaders(headers: InternxtHeaders, resourcesToken?: Token): InternxtHeaders;
export {};
